; Programme assembleur pour 80x86 utilisant les macro-commandes.
; fichier ex-conv.asm.
; Conversion d'un nombre N exprime en base B en base 2, 10 et 16.
; Bertrand Ducourthial. Fevrier 1998. Version 2.

ASSUME CS:CODE, DS:DONNEES

DONNEES SEGMENT
        invite1  DB     10,13,"Programme de conversion : $"
        invite2  DB     10,13,"  donner une base b en decimal (4 chiffres max) : $"
        invite3  DB     10,13,"  donner un nombre en base b (10 chiffres max)  : $"
        invite4  DB     10,13,"     le voici en binaire     : $"
        invite5  DB     10,13,"     le voici en decimal     : $"
        invite6  DB     10,13,"     le voici en hexadecimal : $"
        invite7  DB     10,13,"Voulez-vous recommencer (O/N) : $"
        saisie   DB     32 DUP(32)     ; 32 caracteres espace
        resultat DB     32 DUP(32)     ; 32 caracteres espace
        retour   DB     10,13,"$"      ; Debut de ligne, saut de ligne et fin de
                                       ; chaine.
DONNEES ENDS

CODE    SEGMENT
                INCLUDE macinit.inc    ; Segment de donnees pour les macros.
                INCLUDE macaffi.inc    ; Macro-commandes d'affichage.
                INCLUDE macsais.inc    ; Macro-commandes de saisie.
                INCLUDE macconv.inc    ; Macro-commandes de conversion.

        prog    PROC    NEAR
                MOV     AX, DONNEES
                MOV     DS, AX

        boucle: afficher_texte invite1
                afficher_texte invite2
                saisir_texte 4, saisie             ; saisie <- base B
                                                   ; representee en base 10.
                MOV CX, 10
                convertir_ascii_nombre saisie, CX  ; AX <- base B (nombre).
                MOV     BX, AX                     ; BX <- base B.

                afficher_texte invite3
                saisir_texte 10, saisie            ; saisie <- nombre N
                                                   ; represente en base B.
                convertir_ascii_nombre saisie, BX  ; AX <- N (nombre).

                MOV     CX, 16                     ; Nombre de chiffres max dans
                                                   ; la chaine de caracteres
                                                   ; ascii "resultat".

                convertir_bin_ascii CX, AX, resultat ; resultat <- nombre N
                afficher_texte invite4             ; represente en base 2
                afficher_texte resultat
                afficher_texte retour              ; Saut de ligne.

                convertir_dec_ascii CX, AX, resultat ; resultat <- nombre N
                afficher_texte invite5             ; represente en base 10
                afficher_texte resultat
                afficher_texte retour              ; Saut de ligne.

                convertir_hex_ascii CX, AX, resultat ; resultat <- nombre N
                afficher_texte invite6             ; reresente en base 16.
                afficher_texte resultat
                afficher_texte retour              ; Saut de ligne.


                afficher_texte invite7
                saisir_caractere BH                ; Saisie d'un caractere.
                CMP     BH, 'N'                    ; S'il s'agit de 'N' ou 'n',
                JE      fin                        ; fin du programme.
                CMP     BH, 'n'
                JE fin

                MOV     AX, offset boucle          ; Sinon, on recommence.
                JMP     AX                         ; Saut a longue distance.

           fin: MOV     AX, 4C00h
                INT     21h
        prog    ENDP
CODE    ENDS

END     prog
