; Programme assembleur pour 80x86 utilisant les macro-commandes.
; fichier ex-fich.asm.
; Modification d'un fichier existant.
; Bertrand Ducourthial. Fevrier 1998. Version 2.

ASSUME CS:CODE, DS:DONNEES

DONNEES SEGMENT
        invite1  DB     10,13,"Programme de gestion de fichiers : $"
        invite2  DB     10,13,"  donner un nom de fichier existant : $"
        invite3  DB     10,13,"  taille du fichier (en hexa): $"
        invite4  DB     10,13,"  contenu du fichier (10 premiers octets): $"
        invite6  DB     10,13,"  modification du fichier.$"
        fini     DB     10,13,"C'est fini.$"
        saisie   DB     64 DUP(32) ; 16 caracteres espace. Nom du fichier.
        buffer   DB     20 DUP(32) ; 20 caracteres espace. Tampon en memoire.
        handle   DW     2 DUP(32)  ; 2 caracteres espace. Numero du fichier.
        vide     DB     16 DUP(32) ; 16 caracteres espace.
        taille  DB      16 DUP(32) ; 16 caracteres espace. Taille du fichier.
DONNEES ENDS

CODE    SEGMENT
                INCLUDE macinit.inc   ; Segment de donnees pour les macros.
                INCLUDE macaffi.inc   ; Macro-commandes d'affichage.
                INCLUDE macsais.inc   ; Macro-commandes de saisie.
                INCLUDE macconv.inc   ; Macro-commandes de conversion.
                INCLUDE macfich.inc   ; Macro-commandes de gestion des fichiers.

        prog    PROC    NEAR
                MOV     AX, DONNEES
                MOV     DS, AX

                afficher_texte invite1
                afficher_texte invite2
                saisir_texte 60, saisie              ; Saisie du nom du fichier.

                ouvrir_fichier 2, saisie, 0          ; Ouverture du fichier
                                                     ; en lecture-ecriture.
                MOV handle, AX                       ; Sauvegarde du numero du
                                                     ; fichier.

                calculer_taille_fichier handle       ; Taille dans DX:AX.
                MOV     BX, 4                        ; 5 chiffres decimaux max.
                convertir_hex_ascii BX, DX, taille   ; Poids forts en ascii.
                convertir_hex_ascii BX, AX, taille+4 ; Poids faible en ascii.
                afficher_texte invite3
                afficher_texte taille

                MOV     AX, 10
                lire_fichier handle, AX, buffer      ; Lecture de 10 octets.
                afficher_texte invite4
                MOV     BX, 1                        ; handle 1 = ecran.
                ecrire_fichier BX, AX, buffer        ; Ecriture a l'ecran.

                MOV     CX, 12                       ; 6 boucles.
       boucle:  deplacer_pointeur_fichier handle, CX ; CX octets apres le debut.
                MOV     AX, 1                        ; Ecriture d'un caractere
                ecrire_fichier handle, AX, vide      ; du tampon vide dans le
                                                     ; fichier.
                SUB     CX, 1                        ; CX est decremente de 2,
                LOOP    boucle                       ; arret quand CX = 0.

                fermer_fichier handle
                afficher_texte fini

                MOV     AX, 4C00h
                INT     21h
        prog    ENDP
CODE    ENDS

END     prog
