; Fichier de macro-commandes pour assembleur 80x86
; macaffi.inc : macro-commandes d'affichage de caracteres.
; Bertrand Ducourthial. Fevrier 1998. Version 2.

; ********** Macro d'affichage d'un texte **********
; Entree   : arg 1 : adresse de la chaine a afficher.
; Action   : Affichage de la chaine stockee a l'adresse arg 1.
; Retour   : Aucun.
; Remarque : La chaine pointee par arg 1 doit finir par $.

afficher_texte MACRO _adresse
          ; Sauvegarde des registres utilises dans la macro.
          PUSH    AX
          PUSH    DX

          ; Recuperation des parametres.
          LEA     DX, _adresse

          ; Interruption d'affichage d'une chaine de caractere.
          MOV     AH, 09h
          INT     21h

          ; Restauration des registres empiles.
          POP     DX
          POP     AX
        ENDM


; ********** Macro d'affichage d'un caractere **********
; Entree   : arg 1 : registre contenant le code ascii du caractere.
; Action   : Affichage du caractere correspondant au code ascii de arg 1.
; Retour   : Aucun.
; Remarque :

afficher_caractere MACRO  _registre
          ; Sauvegarde des registres utilises dans la macro.
          PUSH    AX
          PUSH    DX

          ; Interruption d'affichage d'un caractere.
          MOV     DL, _registre
          MOV     AH, 02h
          INT     21h

          ; Restauration des registres empiles.
          POP     DX
          POP     AX
        ENDM

; ********** Macro d'affichage d'un nombre hexadecimal contenu dans AX ******
; Entree   : Nombre dans le registre AX.
; Action   : Affichage du contenu du registre AX en hexadecimal.
; Retour   :
; Remarque : Cette macro necessite l'inclusion des fichiers macinit.inc et
;            macconv.inc.

afficher_nombre_AX MACRO
          ; Sauvegarde des registres utilises dans la macro.
          PUSH  CX
          PUSH  DS

          PUSH    AX                    ; Sauvegarde de la valeur de AX .
          MOV     AX, DONNEES_MACRO     ; Utilisation du segment de donnees
          MOV     DS, AX                ; des macros (cf. macinit.inc) dans
                                        ; toute cette macro.
          POP     AX                    ; Restauration de la valeur de AX.

          MOV     CX, 4                 ; Conversion en ASCII de 4 chiffres
                                        ; hexadecimaux contenus dans AX.
          convertir_hex_ascii CX, AX, saisir_nombre_chaine

          afficher_texte saisir_nombre_invite_affichage  ; Affichage d'un
          afficher_texte saisir_nombre_chaine     ; message et du nombre.
          afficher_texte cr                       ; Saut de ligne.

          ; Restauration des registres empiles.
          POP   DS
          POP   CX
        ENDM

