; Fichier de macro-commandes pour assembleur 80x86
; macpile.inc : macro-commande d'affichage du contenu de la pile.
; Bertrand Ducourthial. Fevrier 1998. Version 2.

; ********** Macro d'affichage du contenu de la pile **********
; Entree   : arg 1 : nombre de lignes de la pile a afficher.
; Action   : Affichage de arg 1 lignes de la pile.
; Retour   : Aucun.
; Remarque : Cette macro necessite l'inclusion des fichiers macinit.inc,
;            macaffi.inc et macconv.inc.

afficher_pile MACRO _nb_lignes
          LOCAL _boucle, _fin
          ; Sauvegarde des registres utilises dans la macro.
          PUSH    AX
          PUSH    BX
          PUSH    CX
          PUSH    DX
          PUSH    BP
          PUSH    SP
          PUSH    DS

          MOV     CX, _nb_lignes      ; Recuperation du parametre.

          MOV     AX, DONNEES_MACRO   ; Utilisation du segment de donnees
          MOV     DS, AX              ; des macros (cf. macinit.inc) dans toute
                                      ; cette macro.

          afficher_texte pile_invite1

          MOV     BP, SP              ; BP sert a lire les lignes de la pile.
                                      ; Initialisation au debut de la pile.
          ADD     BP, 14
 _boucle: MOV     DX, BP              ; Recuperation de l'adresse de la ligne
                                      ; courante dans la pile.
          MOV     BX, 4               ; 4 chiffres hexa a convertir.
          convertir_hex_ascii BX, DX, pile_contenu ; pile_contenu <- adresse
          afficher_texte pile_invite2              ; en ascii. Affichage de
          afficher_texte pile_contenu              ; l'adresse.

          MOV     DX, [BP]            ; Recuperation du contenu de la ligne
                                      ; courante.
          convertir_hex_ascii BX, DX, pile_contenu ; pile_contenu <- contenu
          afficher_texte pile_invite3              ; de la ligne courante
          afficher_texte pile_contenu              ; exprime en hexa. Affichage.

          MOV     BX, 16               ; 16 chiffres binaires a convertir.
          convertir_bin_ascii BX, DX, pile_contenu ; pile_contenu <- contenu de
          afficher_texte pile_invite4              ; la ligne courante exprime
          afficher_texte pile_contenu              ; en binaire. Affichage.

          INC     BP
          INC     BP

          DEC     CX
          CMP     CX, 0
          JE      _fin

          MOV     AX, offset _boucle
          JMP     AX

    _fin: POP     DS
          POP     SP
          POP     BP
          POP     DX
          POP     CX
          POP     BX
          POP     AX
        ENDM
